
@import "CPDictionary.j"

@import "CPExpression.j"

@implementation CPExpression_constant : CPExpression
{
   id _value;
}

- (id)initWithValue:(id)value
{
   [super initWithExpressionType:CPConstantValueExpressionType];
   _value = value;
   return self;
}

- (id)initWithCoder:(CPCoder)coder
{
    var value = [coder decodeObjectForKey:@"CPExpressionConstantValue"];
    return [self initWithValue:value];
}

- (void)encodeWithCoder:(CPCoder)coder
{
    if ([_value respondsToSelector:@selector(encodeOject:forKey:)])
        [coder encodeObject:_value forKey:@"CPExpressionConstantValue"];
}

- (id)constantValue
{
   return _value;
}

- (id)expressionValueWithObject:object context:(CPDictionary)context
{
   return _value;
}

- (CPExpression)_expressionWithSubstitutionVariables:(CPDictionary)variables
{
    return self;
}

- (CPString)description
{
    if ([_value isKindOfClass:[CPString class]])
        return [CPString stringWithFormat:@"\"%s\"",_value];
    else
        return [_value description];
}

@end
