
@import "CPString.j"
@import "CPKeyValueCoding.j"

@import "CPExpression.j"

@implementation CPExpression_keypath : CPExpression
{
   CPString _keyPath;
}

- (id)initWithKeyPath:(CPString)keyPath
{
   [super initWithExpressionType:CPKeyPathExpressionType];
   _keyPath = keyPath ;
   return self;
}

- (id)initWithCoder:(CPCoder)coder
{
    var keyPath = [coder decodeObjectForKey:@"CPExpressionKeyPath"];
    return [self initWithKeyPath:keyPath];
}

- (void)encodeWithCoder:(CPCoder)coder
{
    [coder encodeObject:_keyPath forKey:@"CPExpressionKeyPath"];
}

- (CPString)keyPath
{
   return _keyPath;
}

- (id)expressionValueWithObject:object context:(CPDictionary)context
{
   return [object valueForKeyPath:_keyPath];
}

- (CPExpression)_expressionWithSubstitutionVariables:(CPDictionary)variables
{
    return self;
}

- (CPString)description
{
   return _keyPath;
}

@end
