@import "CPExpression.j"

@implementation CPExpression_unionset

- (id)initWithLeft:(CPExpression)left right:(CPExpression)right
{
   [super initWithExpressionType:CPUnionSetExpressionType];
   _left = left;
   _right = right;
    
   return self;
}

-(id)expressionValueWithObject:object context:(CPDictionary )context
{   
    var right = [_right expressionValueWithObject:object context:context];  
    if (![right respondsToSelector: @selector(objectEnumerator)])
        [CPException raise:CPInvalidArgumentException reason:@"The right expression for a CPIntersectSetExpressionType expression must be either a CPArray, CPDictionary or CPSet"];

    var left = [_left expressionValueWithObject:object context:context];    
    if (![left isKindOfClass:[CPSet set]])
        [CPException raise:CPInvalidArgumentException reason:@"The left expression for a CPIntersectSetExpressionType expression must a CPSet"];

    var unionset = [CPSet setWithSet:left],
        e = [right objectEnumerator],
        item;
    
    while (item = [e nextObject])
        [unionset addObject:item];
        
    return [CPExpression expressionForConstantValue:unionset];
}

- (CPExpression )_expressionWithSubstitutionVariables:(CPDictionary )variables
{
    return self;
}

- (CPString )description
{
   return [_left description] +" UNION "+ [_right description];
}

@end
