
@import "CPString.j"
@import "CPDictionary.j"

@import "CPExpression.j"

@implementation CPExpression_variable :  CPExpression
{
    CPString _variable;
}

- (id)initWithVariable:(CPString)variable
{
   [super initWithExpressionType:CPVariableExpressionType];
   _variable = [variable copy];
   return self;
}

- (id)initWithCoder:(CPCoder)coder
{
    var variable = [coder decodeObjectForKey:@"CPExpressionVariable"];
    return [self initWithVariable:variable];
}

- (void)encodeWithCoder:(CPCoder)coder
{
    [coder encodeObject:_variable forKey:@"CPExpressionVariable"];
}

- (CPString)variable
{
   return _variable;
}

- (id)expressionValueWithObject:object context:(CPDictionary)context
{
   return [context objectForKey:_variable];
}

- (CPString)description
{
   return [CPString stringWithFormat:@"$%s", _variable];
}

- (CPExpression)_expressionWithSubstitutionVariables:(CPDictionary)variables
{
   var aconstant = [variables objectForKey:_variable];
      
   if (aconstant != nil)
     	return [CPExpression expressionForConstantValue:aconstant];
   
   return self;
}


@end
